/***********************************************************************/
/*                                                                     */
/*  FILE        :R8CM12ATEST.c                                         */
/*  DATE        :Mon, Aug 15, 2011                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :M12A                                                  */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.19).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/***********************************************************************/

#include "sfr_r8m12a.h"
#include "uart.h"

void main(void);

void poke(unsigned short address, unsigned char data)
{
	*(unsigned char *) address=data;
}

unsigned char peek(unsigned short address)
{
	return *(unsigned char *) address;
}

void dump(unsigned short address, unsigned short size)
{
	unsigned char count;
	
	while(1)
	{
		puthexshort(address);
		putch(' ');
	
		for(count=16; count!=0; count--)
		{
			if(size==0)return;
			puthex(peek(address));
			putch(' ');
			address++;
			size--;
		}
		puts("\r\n");
		if(size==0)return;
	}
}

void main(void)
{
	unsigned short address;
	unsigned char temp;
	
	osc_init();
	uart_init();
	
	for(address=0x500; address!=0xC00; address++)
	{
		poke(address,0x55);
		if(peek(address)!=0x55) break;	// 0x55Ă݂0x55ǂݏo
		poke(address,0xAA);
		if(peek(address)!=0xAA) break;	// 0xAAĂ݂0xAAǂ߂A͂ԂRAM
	}
	
	while(1)
	{
		puts("\r\n> ");
		while(1)
		{
			temp=getch();
			putch(temp);
			if(temp=='\r')break;
		}	
		puts("\r\n");
		dump(0,0xFFFF);
	
		puts("\r\n\r\n");
		puts("RAM : 0x0400 - 0x");
		puthexshort(address-1);
		puts("\r\n");

	// 茳̃foCX
	// RAM 			0x0300 - 0x03FF g( 256B)
	// RAM 			0x0400 - 0x07FF ( 1KB)
	// DATA FLASH 	0x3000 - 0x37FF ( 2KB)
	// PROGRAM ROM 	0x8000 - 0xFFFF (32KB)
	// 
	
	// ZNV̐ݒROM̐擪AhX 0x8000 ɕύX΁AvOROM 32KBgăvOB
	// RpCRAM͈̔͂`FbNĂȂ̂ŁARAM̐ݒ͕KvȂi0x0300 - 0x03FF gȂARAM̐擪AhX 0x0300 ɕύXj
	// FDT̃foCXI R5F2M120A IԂƁAݎROM͈̔͂𒴂ĂƃG[ɂȂ̂
	// R5F2M120A Əݕ@(R8C/MxV[Y, LAxAO[vVAvgRdl) R5F2LA86A (ROM32KB)IׂΏ݂ł
	// R5F2M120A  R5F2LA86A ̓f[^tbṼAhXȂ̂ŁAȂ
	
	}
}
